#ifndef VECTOR_HPP
#define VECTOR_HPP

template<typename T>
class Vector
{
public:
    Vector() = default;
    Vector(size_t size);
    Vector(const Vector&);
    Vector(Vector&&);

    Vector& operator=(const Vector&);
    Vector& operator=(Vector&&);

    void push_back(const T&);
    T pop_back();

    T* begin();
    const T* begin() const;

    T* end();
    const T* end() const;

    T& operator[](size_t at);
    const T& operator[](size_t at) const;

    ~Vector();
private:
    void swap(const Vector<T>& other);

    T* data_ = nullptr;
    size_t size_ = 0;
    size_t count_ = 0;

};


template<typename T>
inline Vector<T>::Vector(size_t size)
    : size_(size), count_(0), data_(new T[size_])
{
}

template<typename T>
inline Vector<T>::Vector(const Vector<T> & other)
    : Vector<T>(other.size_)
{
    
}

template<typename T>
inline Vector<T>::Vector(Vector &&)
{
}

template<typename T>
inline Vector<T> & Vector<T>::operator=(const Vector<T> & other)
{
    return *this = Vector<T>(other);
}

template<typename T>
inline Vector<T> & Vector<T>::operator=(Vector<T> && other)
{
    swap(other);
    return *this;
}

template<typename T>
inline void Vector<T>::push_back(const T & value)
{
    if (is_full())
    {
        resize(size_*2 ? size_*2 : 1)
    }
    data[count_++] = value;
}

template<typename T>
inline T Vector<T>::pop_back()
{
    return T();
}

template<typename T>
inline T * Vector<T>::begin()
{
    return NULL;
}

template<typename T>
inline const T * Vector<T>::begin() const
{
    return NULL;
}

template<typename T>
inline T * Vector<T>::end()
{
    return NULL;
}

template<typename T>
inline const T * Vector<T>::end() const
{
    return NULL;
}

template<typename T>
inline T & Vector<T>::operator[](size_t at)
{
    // TODO: insert return statement here
}

template<typename T>
inline const T & Vector<T>::operator[](size_t at) const
{
    // TODO: insert return statement here
}

template<typename T>
inline Vector<T>::~Vector()
{
}

template<typename T>
inline void Vector<T>::swap(const Vector<T>& other)
{
    std::swap(data_, other.data_);
    std::swap(size_, other.size_);
    std::swap(count_, other.count_);
}



#endif // VECTOR_HPP

