#include <iostream> 
#include <random>

#include "Vector.h"

template<typename T = double>
struct RadianDegree
{
    T value = 0;
    RadianDegree() = default;
    RadianDegree(T value)
        : value(value)
    {
    }
};

template <typename T>
std::ostream& operator<<(std::ostream& os, const RadianDegree<T>& radian_degree)
{
    os << radian_degree.value;
    return os;
}

int main(void)
{
    auto v = Vector<RadianDegree<>>();

    for (int i = 0; i < 10; ++i)
    {
        v.push_back(RadianDegree<>(i));
    }

    for (auto& radian_degree : v)
    {
        std::cout << radian_degree << " ";
    }
}

//int main(void)
//{
//    auto polygon = Polygon(2);
//    polygon.push(get_point()); // ok
//    polygon.push(get_point()); // ok
//    polygon.push(get_point()); // blad
//
//    getchar();
//    return 0;
//}
